#pragma once

#include "CoreMinimal.h"
#include "BaseLingeringStatusEffect.h"
#include "DBDTunableRowHandle.h"
#include "GameplayTagContainer.h"
#include "GameEventData.h"
#include "K38KillerInstinctLingeringEffect.generated.h"

class AK38Dog;

UCLASS(Blueprintable, EditInlineNew, meta=(BlueprintSpawnableComponent))
class THEK38_API UK38KillerInstinctLingeringEffect : public UBaseLingeringStatusEffect
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FDBDTunableRowHandle _dogDetectionRadiusStart;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _maximumDetectionHeightDifference;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	AK38Dog* _dogInRange;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, ReplicatedUsing=OnRep_IsInDogDetectionRadius, meta=(AllowPrivateAccess=true))
	bool _isInDogDetectionRadius;

private:
	UFUNCTION(BlueprintCallable)
	void OnRep_IsInDogDetectionRadius();

	UFUNCTION()
	void Authority_OnSurvivorCrouchChanged(const FGameplayTag gameEvent, const FGameEventData& gameEventData);

public:
	virtual void GetLifetimeReplicatedProps(TArray<FLifetimeProperty>& OutLifetimeProps) const override;

public:
	UK38KillerInstinctLingeringEffect();
};

FORCEINLINE uint32 GetTypeHash(const UK38KillerInstinctLingeringEffect) { return 0; }
